# *****************************************************************************
# *****************************************************************************

# OpenStreetMaps

# general

KEY_OSM_CITY = "addr:city"
KEY_OSM_COUNTRY = "addr:country"
KEY_OSM_HOUSE_NUMBER = "addr:housenumber"
KEY_OSM_MUNICIPALITY = "addr:municipality"
KEY_OSM_PLACE = "addr:place"
KEY_OSM_POSTCODE = "addr:postcode"
KEY_OSM_STREET = "addr:street"
KEY_OSM_SOURCE = "source"

KEYS_OSM = [
    KEY_OSM_CITY,
    KEY_OSM_COUNTRY,
    KEY_OSM_HOUSE_NUMBER,
    KEY_OSM_MUNICIPALITY,
    KEY_OSM_PLACE,
    KEY_OSM_POSTCODE,
    KEY_OSM_STREET,
    KEY_OSM_SOURCE,
]

# country specific

KEY_COUNTRY_DK = "dk"

KEY_OSM_DK_BUILDING_ENTRANCE_ID = "osak:identifier"

KEY_OSM_BUILDING_ENTRANCE_ID = {KEY_COUNTRY_DK: KEY_OSM_DK_BUILDING_ENTRANCE_ID}


# *****************************************************************************

# osmnx

KEY_OSMNX_OSMID = "osmid"
KEY_OSMNX_ELEMENT_TYPE = "element_type"

KEY_OSMNX_NAME = "name"
KEY_OSMNX_GEOMETRY = "geometry"
KEY_OSMNX_REVERSED = "reversed"
KEY_OSMNX_LENGTH = "length"
KEY_OSMNX_ONEWAY = "oneway"
KEY_OSMNX_X = "x"
KEY_OSMNX_Y = "y"
KEY_OSMNX_LON = "lon"
KEY_OSMNX_LAT = "lat"
KEY_OSMNX_STREET_COUNT = "street_count"

KEYS_OSMNX = [
    KEY_OSMNX_OSMID,  # one half of multi-index for geodataframes from osmnx
    KEY_OSMNX_ELEMENT_TYPE,  # the other half of the multi-index from osmnx
    KEY_OSMNX_NAME,
    KEY_OSMNX_GEOMETRY,
    KEY_OSMNX_REVERSED,
    KEY_OSMNX_LENGTH,
    KEY_OSMNX_ONEWAY,
    KEY_OSMNX_X,
    KEY_OSMNX_Y,
    KEY_OSMNX_LON,
    KEY_OSMNX_LAT,
    KEY_OSMNX_STREET_COUNT,
]

KEYS_OSMNX_NODES = {
    KEY_OSMNX_OSMID,
    KEY_OSMNX_NAME,
    KEY_OSMNX_STREET_COUNT,
    KEY_OSMNX_X,
    KEY_OSMNX_Y,
    KEY_OSMNX_LON,
    KEY_OSMNX_LAT,
    KEY_OSMNX_STREET_COUNT,
}

KEYS_OSMNX_NODES_ESSENTIAL = {KEY_OSMNX_OSMID, KEY_OSMNX_NAME, KEY_OSMNX_STREET_COUNT}

KEYS_OSMNX_EDGES = {
    KEY_OSMNX_OSMID,
    KEY_OSMNX_LENGTH,
    KEY_OSMNX_ONEWAY,
    KEY_OSMNX_GEOMETRY,
    KEY_OSMNX_REVERSED,
}

KEYS_OSMNX_EDGES_ESSENTIAL = {
    KEY_OSMNX_OSMID,
    KEY_OSMNX_LENGTH,
    KEY_OSMNX_ONEWAY,
    KEY_OSMNX_REVERSED,
}

# *****************************************************************************
